from abc import ABCMeta, abstractmethod

class CommsInterface():
    __metaclass__ = ABCMeta

    @abstractmethod
    def connect(self):
        pass

    @abstractmethod
    def disconnect(self):
        pass

    @abstractmethod
    def is_up(self):
        pass

    @abstractmethod
    def get_priority(self):
        pass
