# from http://stackoverflow.com/questions/358471/xmodem-for-python
import serial
try:
    from cStringIO import StringIO
except:
    from StringIO import StringIO
from xmodem import XMODEM, NAK
from time import sleep

def readUntil(char = None):
    def serialPortReader():
        while True:
            tmp = port.read(1)
            if not tmp or (char and char == tmp):
                break
            yield tmp
    return ''.join(serialPortReader())

def getc(size, timeout=1):
    return port.read(size)

def putc(data, timeout=1):
    port.write(data)
    sleep(0.001) # give device time to prepare new buffer and start sending it

port = serial.Serial(port='/dev/ttyUSB0',timeout=1,baudrate=460800)
port.write("dl find\n")
#sleep(0.2) # give device time to handle command and start sending response
readUntil(NAK)
modem = XMODEM(getc, putc)
f = open("2", "wb")
print modem.recv(f, timeout=0,delay=0)
f.flush()
f.close()
readUntil()
