#!/bin/sh
# Handles various setup tasks requried on each boot


#MUX the GPIO
echo "7" > /sys/kernel/debug/omap_mux/gpmc_ad0
echo "7" > /sys/kernel/debug/omap_mux/gpmc_ad1
echo "7" > /sys/kernel/debug/omap_mux/gpmc_ad2
echo "7" > /sys/kernel/debug/omap_mux/gpmc_ad3

#Export the GPIO
echo "32" > /sys/class/gpio/export
echo "33" > /sys/class/gpio/export
echo "34" > /sys/class/gpio/export
#echo "35" > /sys/class/gpio/export
#seems to be broken at the mo

#MUX the serial ports
#ttyO1
echo 0 > /sys/kernel/debug/omap_mux/uart1_txd
echo 20 > /sys/kernel/debug/omap_mux/uart1_rxd
ln -s /dev/ttyO1 /dev/gprs-serial
#ttyO2
echo 1 > /sys/kernel/debug/omap_mux/spi0_d0
echo 21 > /sys/kernel/debug/omap_mux/spi0_sclk
ln -s /dev/ttyO2 /dev/weather-serial
ln -s /dev/ttyO2 /dev/probe-serial
#ttyO4
echo 06 > /sys/kernel/debug/omap_mux/gpmc_wpn
echo 26 > /sys/kernel/debug/omap_mux/gpmc_wait0
ln -s /dev/ttyO4 /dev/gps-serial
#ttyO5
echo 4 >  /sys/kernel/debug/omap_mux/lcd_data8
echo 24 >  /sys/kernel/debug/omap_mux/lcd_data9

#Setup RTC
echo ds3232 0x68 >/sys/bus/i2c/devices/i2c-3/new_device
sleep 5
/sbin/hwclock -f /dev/rtc1 -s 
date >> /root/date

#TEST CO
/root/code/gwcamera.py -d -C -i > /dev/null 2>&1 
